package com.gic.store.utils;

import com.gic.log.api.dto.SystemSetLogDTO;
import com.gic.log.api.service.LogApiService;
import org.springframework.beans.BeanWrapper;
import org.springframework.beans.BeanWrapperImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.beans.PropertyDescriptor;
import java.util.Date;

/**
 * @author zhiwj
 * @date 2019/7/10
 */
@Component
public class LogUtils {

    private static LogApiService logApiService;

    @Autowired
    public void setLogApiService(LogApiService logApiService) {
        LogUtils.logApiService = logApiService;
    }

    public static <T> void saveLog(T obj) {
        // 日志
        SystemSetLogDTO systemSetLogDTO = new SystemSetLogDTO();
//        systemSetLogDTO.setEnterpriesId(storeBrandDTO.getEnterpriseId() + "");
        systemSetLogDTO.setLogTime(new Date());
//        systemSetLogDTO.setInterfaceName("com.gic.store.service.StoreBrandApiService.saveOrUpdateStoreBrand");

        final BeanWrapper dtoBean = new BeanWrapperImpl(obj);
        PropertyDescriptor[] pds = dtoBean.getPropertyDescriptors();
        StringBuilder content = new StringBuilder();
        for (PropertyDescriptor pd : pds) {
            Object value = dtoBean.getPropertyValue(pd.getName());
            if (value != null) {
                if ("enterpriseId".equalsIgnoreCase(pd.getName())) {
                    systemSetLogDTO.setEnterpriesId(value.toString());
                } else {
                    content.append(pd.getName()).append(":").append(value).append("<br/>");
                }
            }
        }
        systemSetLogDTO.setContent(content.toString());
        logApiService.saveSystemSetLog(systemSetLogDTO);
    }


}
